/**
 * SearchRequest.java
 *
 * File generated from the core::SearchRequest uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

/**
 * Description of the class SearchRequest.
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "SearchRequest", propOrder = { "filter", "attributes",
		"derefAliases", "dn", "scope", "sizeLimit", "timeLimit", "typesOnly" })
@XmlRootElement(name = "SearchRequest")
public class SearchRequest extends net.ihe.gazelle.hpd.DsmlMessage implements
		java.io.Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@XmlElement(name = "filter", required = true, namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.Filter filter;
	@XmlElement(name = "attributes", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.AttributeDescriptions attributes;
	@XmlAttribute(name = "derefAliases", required = true)
	public net.ihe.gazelle.hpd.DerefAliasesType derefAliases;
	@XmlAttribute(name = "dn", required = true)
	public java.lang.String dn;
	@XmlAttribute(name = "scope", required = true)
	public net.ihe.gazelle.hpd.ScopeType scope;
	@XmlAttribute(name = "sizeLimit")
	public java.lang.String sizeLimit;
	@XmlAttribute(name = "timeLimit")
	public java.lang.String timeLimit;
	@XmlAttribute(name = "typesOnly")
	public Boolean typesOnly;
	
	public SearchRequest(){
		super();
	}

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;

	/**
	 * Return filter.
	 * 
	 * @return filter
	 */
	public net.ihe.gazelle.hpd.Filter getFilter() {
		return filter;
	}

	/**
	 * Set a value to attribute filter.
	 * 
	 * @param filter
	 *            .
	 */
	public void setFilter(net.ihe.gazelle.hpd.Filter filter) {
		this.filter = filter;
	}

	/**
	 * Return attributes.
	 * 
	 * @return attributes
	 */
	public net.ihe.gazelle.hpd.AttributeDescriptions getAttributes() {
		return attributes;
	}

	/**
	 * Set a value to attribute attributes.
	 * 
	 * @param attributes
	 *            .
	 */
	public void setAttributes(
			net.ihe.gazelle.hpd.AttributeDescriptions attributes) {
		this.attributes = attributes;
	}

	/**
	 * Return derefAliases.
	 * 
	 * @return derefAliases
	 */
	public net.ihe.gazelle.hpd.DerefAliasesType getDerefAliases() {
		return derefAliases;
	}

	/**
	 * Set a value to attribute derefAliases.
	 * 
	 * @param derefAliases
	 *            .
	 */
	public void setDerefAliases(
			net.ihe.gazelle.hpd.DerefAliasesType derefAliases) {
		this.derefAliases = derefAliases;
	}

	/**
	 * Return dn.
	 * 
	 * @return dn
	 */
	public java.lang.String getDn() {
		return dn;
	}

	/**
	 * Set a value to attribute dn.
	 * 
	 * @param dn
	 *            .
	 */
	public void setDn(java.lang.String dn) {
		this.dn = dn;
	}

	/**
	 * Return scope.
	 * 
	 * @return scope
	 */
	public net.ihe.gazelle.hpd.ScopeType getScope() {
		return scope;
	}

	/**
	 * Set a value to attribute scope.
	 * 
	 * @param scope
	 *            .
	 */
	public void setScope(net.ihe.gazelle.hpd.ScopeType scope) {
		this.scope = scope;
	}

	/**
	 * Return sizeLimit.
	 * 
	 * @return sizeLimit
	 */
	public java.lang.String getSizeLimit() {
		return sizeLimit;
	}

	/**
	 * Set a value to attribute sizeLimit.
	 * 
	 * @param sizeLimit
	 *            .
	 */
	public void setSizeLimit(java.lang.String sizeLimit) {
		if (sizeLimit != null && !sizeLimit.isEmpty()){
			this.sizeLimit = sizeLimit;
		}else{
			this.sizeLimit = null;
		}
	}
	
	public void setSizeLimit(java.lang.Integer sizeLimit){
		if (sizeLimit != null){
			this.sizeLimit = Integer.toString(sizeLimit);
		}else{
			this.sizeLimit = null;
		}
	}

	/**
	 * Return timeLimit.
	 * 
	 * @return timeLimit
	 */
	public java.lang.String getTimeLimit() {
		return timeLimit;
	}

	/**
	 * Set a value to attribute timeLimit.
	 * 
	 * @param timeLimit
	 *            .
	 */
	public void setTimeLimit(java.lang.String timeLimit) {
		if (timeLimit != null && !timeLimit.isEmpty()) {
			this.timeLimit = timeLimit;
		}else{
			this.timeLimit = null;
		}
	}
	
	public void setTimeLimit(java.lang.Integer timeLimit){
		if (timeLimit != null){
			this.timeLimit = Integer.toString(timeLimit);
		}else{
			this.timeLimit = null;
		}
	}

	/**
	 * Return typesOnly.
	 * 
	 * @return typesOnly
	 */
	public Boolean getTypesOnly() {
		return typesOnly;
	}

	/**
	 * Set a value to attribute typesOnly.
	 * 
	 * @param typesOnly
	 *            .
	 */
	public void setTypesOnly(Boolean typesOnly) {
		this.typesOnly = typesOnly;
	}

	/**
	 * Return typesOnly.
	 * 
	 * @return typesOnly Generated for the use on jsf pages
	 */
	@Deprecated
	public Boolean isTypesOnly() {
		return typesOnly;
	}

	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null) {
			JAXBContext jc;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			DocumentBuilder db = null;
			Document doc = null;
			try {
				db = dbf.newDocumentBuilder();
				doc = db.newDocument();
			} catch (ParserConfigurationException e1) {
			}
			try {
				jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
				Marshaller m = jc.createMarshaller();
				m.marshal(this, doc);
				_xmlNodePresentation = doc.getElementsByTagNameNS(
						"urn:oasis:names:tc:DSML:2:0:core", "SearchRequest")
						.item(0);
			} catch (JAXBException e) {
				try {
					db = dbf.newDocumentBuilder();
					_xmlNodePresentation = db.newDocument();
				} catch (Exception ee) {
				}
			}
		}
		return _xmlNodePresentation;
	}

	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}

	/**
	 * validate by a module of validation
	 * 
	 */
	public static void validateByModule(SearchRequest searchRequest,
			String _location, ConstraintValidatorModule cvm,
			List<net.ihe.gazelle.validation.Notification> diagnostic) {
		if (searchRequest != null) {
			net.ihe.gazelle.hpd.DsmlMessage.validateByModule(searchRequest,
					_location, cvm, diagnostic);
			net.ihe.gazelle.hpd.Filter.validateByModule(
					searchRequest.getFilter(), _location + "/filter", cvm,
					diagnostic);
			net.ihe.gazelle.hpd.AttributeDescriptions.validateByModule(
					searchRequest.getAttributes(), _location + "/attributes",
					cvm, diagnostic);
		}
	}

}